# - Try to find CEGUI
# Once done this will define
#  
#  CEGUI_FOUND        - system has CEGUI
#  CEGUI_INCLUDE_DIR  - the CEGUI include directory
#  CEGUI_LIBRARIES    - Link these to use CEGUI

if(UNIX)
set(CEGUI_DEBUG_SUFFIX "")
else()
set(CEGUI_DEBUG_SUFFIX "_d")
endif()

# Set this to point to your own cegui installation directory if available.
set(CEGUI_SELF_INSTALLATION_DIR "C:/Projects/CEGUI-0.7.1")

find_library( CEGUI_LIBRARY_BASE CEGUIBase_Static
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_BASE_D CEGUIBase_Static${CEGUI_DEBUG_SUFFIX}
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_WRBASE CEGUIFalagardWRBase_Static
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_WRBASE_D CEGUIFalagardWRBase_Static${CEGUI_DEBUG_SUFFIX}
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_XMLPARSER CEGUIExpatParser_Static
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_XMLPARSER_D CEGUIExpatParser_Static${CEGUI_DEBUG_SUFFIX}
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_IMLOADER CEGUITGAImageCodec_Static
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)
find_library( CEGUI_LIBRARY_IMLOADER_D CEGUITGAImageCodec_Static${CEGUI_DEBUG_SUFFIX}
	PATHS ${REND_DEP_LIB_DIR} /usr/local/lib /usr/lib
	${CEGUI_SELF_INSTALLATION_DIR}/lib
)

find_path( CEGUI_INCLUDE_DIR CEGUI.h
	PATHS
	${REND_DEP_INC_DIR} 
	$ENV{CEGUI_DIR}/include 
	/usr/local/include 
	/usr/include 
	${CEGUI_SELF_INSTALLATION_DIR}/cegui/include
	PATH_SUFFIXES CEGUI
)

if(CEGUI_LIBRARY_BASE AND CEGUI_LIBRARY_WRBASE AND 
   CEGUI_LIBRARY_XMLPARSER AND CEGUI_LIBRARY_IMLOADER)
	set(CEGUI_LIBRARIES_R_FOUND "TRUE")
	set(CEGUI_LIBRARIES_R
		optimized ${CEGUI_LIBRARY_BASE} 
		optimized ${CEGUI_LIBRARY_WRBASE} 
		optimized ${CEGUI_LIBRARY_XMLPARSER} 
		optimized ${CEGUI_LIBRARY_IMLOADER}
	)
endif()

if(CEGUI_LIBRARY_BASE_D AND CEGUI_LIBRARY_WRBASE_D AND 
   CEGUI_LIBRARY_XMLPARSER_D AND CEGUI_LIBRARY_IMLOADER_D )
	set(CEGUI_LIBRARIES_D_FOUND "TRUE")
	set(CEGUI_LIBRARIES_D
		debug ${CEGUI_LIBRARY_BASE_D} 
		debug ${CEGUI_LIBRARY_WRBASE_D} 
		debug ${CEGUI_LIBRARY_XMLPARSER_D} 
		debug ${CEGUI_LIBRARY_IMLOADER_D}
	)
endif()

if(CEGUI_INCLUDE_DIR AND CEGUI_LIBRARIES_D_FOUND AND CEGUI_LIBRARIES_R_FOUND )
	SET(CEGUI_FOUND "YES")
	SET(CEGUI_LIBRARIES ${CEGUI_LIBRARIES_D} ${CEGUI_LIBRARIES_R} )
endif()

if(CEGUI_FOUND)
	MESSAGE("CEGUI Desktop Library is found.")
	MESSAGE("CEGUI_LIBRARIES_D :" ${CEGUI_LIBRARIES_D})
	MESSAGE("CEGUI_LIBRARIES_R :" ${CEGUI_LIBRARIES_R})
else()
	MESSAGE("CEGUI Desktop Library is not found.")
endif()

mark_as_advanced(
	CEGUI_INCLUDE_DIR
	CEGUI_LIBRARIES
	CEGUI_LIBRARY_BASE CEGUI_LIBRARY_BASE_D
	CEGUI_LIBRARY_WRBASE CEGUI_LIBRARY_WRBASE_D
	CEGUI_LIBRARY_XMLPARSER CEGUI_LIBRARY_XMLPARSER_D
	CEGUI_LIBRARY_IMLOADER CEGUI_LIBRARY_IMLOADER_D
)
