/****************************************************************************
Copyright 2010 Bilkent University

Licensed under the Apache License, Version 2.0 (the "License"); 
you may not use this file except in compliance with the License. 
You may obtain a copy of the License at 
http://www.apache.org/licenses/LICENSE-2.0 

Unless required by applicable law or agreed to in writing, software 
distributed under the License is distributed on an "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
See the License for the specific language governing permissions and 
limitations under the License. 
****************************************************************************/
#include "REng/MultiViewCompositor.h"

namespace REng{

	MultiViewCompositor::MultiViewCompositor(uchar viewCount)
		:mIsSupported(false)
		,mIsInitialized(false)
		,mViewCount(viewCount)
	{ ; }

	bool MultiViewCompositor::isSupported() const{
		return mIsSupported;
	}
	uchar MultiViewCompositor::getViewCount() const{
		return mViewCount;
	}
	bool MultiViewCompositor::beginFrame() { return true; }
	bool MultiViewCompositor::endFrame()   { return true; }
	bool MultiViewCompositor::mergeViews(MultiViewBuffer& mvb) { 
		return true;
	}
	bool MultiViewCompositor::setActiveView(size_t viewIndex){ 
		return true; 
	}
	bool MultiViewCompositor::isInitialized() const{
		return mIsInitialized;
	}

} // namespace REng

