/****************************************************************************
Copyright 2010 Bilkent University

Licensed under the Apache License, Version 2.0 (the "License"); 
you may not use this file except in compliance with the License. 
You may obtain a copy of the License at 
http://www.apache.org/licenses/LICENSE-2.0 

Unless required by applicable law or agreed to in writing, software 
distributed under the License is distributed on an "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
See the License for the specific language governing permissions and 
limitations under the License. 
****************************************************************************/
#include "REng/Timer.h"

#include <cstdio>

using namespace std;

namespace REng{

	Timer::Timer() {
		reset();
	}

	void Timer::reset() {
		#ifdef _WIN32
			base = GetTickCount();
		#else
			gettimeofday(&base,NULL);
		#endif
	}


	float Timer::getElapsedTime(bool _reset, float threshold) {
		float retval;
		#ifdef _WIN32
			DWORD now;
			now=GetTickCount();
			retval=(float)(now-base)/1000.0f;
		#else
			struct timeval now;
			gettimeofday(&now,NULL);
			retval=(now.tv_sec-base.tv_sec)+((float)(now.tv_usec-base.tv_usec)/1000000.0f);
		#endif
		// check for threshold
		if(retval<=threshold){
			return 0;
		}
		if(_reset==false) {
			return retval;
		} else {
			base=now;
			return retval;
		}

	}

}

