inline BodyNodeLink::BodyNodeLink()
	:mUseCollisionProxy(false){ }

inline void BodyNodeLink::setPhyBody(RigidBody& body) { 
	mBody = &body;
	body.mOwnerSceneBody = this;
}
inline REng::GeomAxisAlignedBox BodyNodeLink::getWorldSpaceBox() const{
	// create the transformed bounding box of the body

	REng::GeomAxisAlignedBox bBox(mBoundingBox);
	// 1. rotate
	bBox.rotate_World(mBody->getRotation());
	// 2. translate
	bBox.translate_World(mBody->getPosition());

	return bBox;
}
inline void BodyNodeLink::setREngNode(REng::SceneNode& node){
	mSceneNode = &node;
}
inline REng::SceneNode& BodyNodeLink::getNode(){
	return *mSceneNode;
}
inline const REng::SceneNode& BodyNodeLink::getNode() const{
	return *mSceneNode;
}
inline REng::SceneNodeType BodyNodeLink::getNodeType() const{
	if(!mSceneNode) return REng::SceneNode_Group;
	return mSceneNode->getType();
}
inline const REng::MeshNode& BodyNodeLink::getMeshNode() const{
	return *((REng::MeshNode*)mSceneNode);
}
inline REng::MeshNode& BodyNodeLink::getMeshNode(){
	return *((REng::MeshNode*)mSceneNode);
}
